diff -bru bochs-2.1.pre3/bochs.h bochs-2.1.pre3.patched/bochs.h
--- bochs-2.1.pre3/bochs.h	2004-02-01 16:00:05.000000000 -0600
+++ bochs-2.1.pre3.patched/bochs.h	2004-02-01 11:48:58.000000000 -0600
@@ -451,6 +451,9 @@
 #ifdef MAGIC_BREAKPOINT
   bx_bool magic_break_enabled;
 #endif /* MAGIC_BREAKPOINT */
+#ifdef BX_GDBSTUB
+  bx_bool gdbstub_enabled;
+#endif
 #if BX_SUPPORT_APIC
   bx_bool apic;
   bx_bool ioapic;
diff -bru bochs-2.1.pre3/cpu/cpu.cc bochs-2.1.pre3.patched/cpu/cpu.cc
--- bochs-2.1.pre3/cpu/cpu.cc	2004-02-01 16:00:05.000000000 -0600
+++ bochs-2.1.pre3.patched/cpu/cpu.cc	2004-02-01 11:48:58.000000000 -0600
@@ -485,6 +485,7 @@
 
 #endif  // #if BX_DEBUGGER
 #if BX_GDBSTUB
+    if(bx_dbg.gdbstub_enabled)
     {
     unsigned int reason;
     if ((reason = bx_gdbstub_check(EIP)) != GDBSTUB_STOP_NO_REASON) {
diff -bru bochs-2.1.pre3/main.cc bochs-2.1.pre3.patched/main.cc
--- bochs-2.1.pre3/main.cc	2004-02-01 16:00:05.000000000 -0600
+++ bochs-2.1.pre3.patched/main.cc	2004-02-01 11:48:58.000000000 -0600
@@ -2288,16 +2288,19 @@
     BX_PANIC (("no gui module was loaded"));
     return 0;
   }
-#if BX_GDBSTUB
-  // If using gdbstub, it will take control and call
-  // bx_init_hardware() and cpu_loop()
-  bx_gdbstub_init (argc, argv);
-#elif BX_DEBUGGER
+#if BX_DEBUGGER
   // If using the debugger, it will take control and call
   // bx_init_hardware() and cpu_loop()
   bx_dbg_main(argc, argv);
 #else
-
+#if BX_GDBSTUB
+  // If using gdbstub, it will take control and call
+  // bx_init_hardware() and cpu_loop()
+  if(bx_dbg.gdbstub_enabled) {
+    bx_gdbstub_init (argc, argv);
+  } else
+#endif
+  {
 #if BX_USE_PLEX86
   // If plex86 is requested, open plex86 device.
   if (plex86Open() > -1)
@@ -2349,6 +2352,7 @@
             BX_TICKN(quantum);
     }
   }
+  }
 #endif
   BX_INFO (("cpu loop quit, shutting down simulator"));
   bx_atexit ();
@@ -2563,6 +2567,9 @@
 #ifdef MAGIC_BREAKPOINT
   bx_dbg.magic_break_enabled = 0;
 #endif
+#ifdef BX_GDBSTUB
+  bx_dbg.gdbstub_enabled = 0;
+#endif
 
 }
 
@@ -3838,6 +3845,27 @@
         }
       }
     }
+#ifdef BX_GDBSTUB
+  else if (!strcmp(params[0], "gdbstub")) {
+    if (num_params != 2) {
+      PARSE_ERR(("%s: gdbstub directive: wrong # args.", context));
+      }
+    if (strncmp(params[1], "enabled=", 8)) {
+      PARSE_ERR(("%s: gdbstub directive malformed.", context));
+      }
+    if (params[1][8] == '0') {
+      BX_INFO(("Disabled gdbstub"));
+      bx_dbg.gdbstub_enabled = 0;
+      }
+    else if (params[1][8] == '1') {
+      BX_INFO(("Enabled gdbstub"));
+      bx_dbg.gdbstub_enabled = 1;
+      }
+    else {
+      PARSE_ERR(("%s: gdbstub directive malformed.", context));
+      }
+    }
+#endif
 #ifdef MAGIC_BREAKPOINT
   else if (!strcmp(params[0], "magic_break")) {
     if (num_params != 2) {
